SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[UpdateNluAppId]
(
	@VCC	    VARCHAR(50),
	@AppId      VARCHAR(50),
	@NewAppId   VARCHAR(50),
	@Culture    VARCHAR(10) = '',
	@CognitiveEngine  VARCHAR(50) = '',
    @UseRasaApi BIT = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	--ACTUALIZAR LOS REGISTROS CON EL NUEVO APPID
	IF (@CognitiveEngine = 'NEW_RASA_ENGINE' AND @UseRasaApi = 1)
	SET @CognitiveEngine  = 'RASAAPI'
	
    IF (@CognitiveEngine = 'NEW_RASA_ENGINE' AND @UseRasaApi = 0)
	SET @CognitiveEngine  = 'RASA'

	--CONSULTAR SI AL MENOS TIENE UNA INTENCION Y FRASES PARA ENVIAR A ENTRENAR
	DECLARE @MinUtteranceNumber INT
	SELECT  @MinUtteranceNumber = COUNT(*) FROM dbo.[Utterance] U
	INNER JOIN dbo.[Intent] I ON 
	U.IntentId = I.IntentId
	AND U.VCC =I.VCC
	WHERE U.VCC = @VCC 
	AND U.AppId = @AppId
	
	UPDATE [dbo].[NLU] 
	SET [AppId] = @NewAppId,
	[Culture] = @Culture,
	[LastPublishedDate] = NULL,
	[LastTrainedDate] = NULL,
	[LastModifiedDate] = GETUTCDATE(),
	[IsPublished] = 0,
	[IsTrained] = 0,
	[NeedTrain] = IIF(@MinUtteranceNumber >= 1, 1, 0),
	[NeedPublish] = 0,
	[TrainVersion] = null,
	[TrainId]= null,
	[CognitiveEngine] = @CognitiveEngine
	WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Intent] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Utterance] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId
	
	UPDATE [dbo].[Entity] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
